from sdetools.sdelib.cmd import BaseCommand
from sdetools.modules.import_checkmarx.checkmarx_integrator import CheckmarxIntegrator, CheckmarxSOAPApi

class Command(BaseCommand):
    help = 'Checkmarx -> SDE import utility.'

    def configure(self):
        self.cx_api = CheckmarxSOAPApi(self.config)
        self.cx_integrator = CheckmarxIntegrator(self.cx_api, self.config)

    def handle(self):
        self.cx_integrator.initialize()
        self.cx_integrator.load_mapping_from_xml()
        self.cx_integrator.parse()
        self.emit.info('Finding file parsed successfully. Starting the import')
        self.cx_integrator.import_findings()
 
