from sdetools.analysis_integration.base_integrator import BaseXMLImporter, BaseContentHandler


class CheckmarxXMLContent(BaseContentHandler):
    def __init__(self):
        self.saw_cx_xml_results = False
        self.in_cx_xml_results_node = False
        self.in_query_node = False
        self.in_result_node = False
        self.findings = []
        self.id = None
        self.cwe_id = None
        self.weakness_name = None

    def valid_content_detected(self):
        return self.saw_cx_xml_results

    def processingInstruction(self, target, data):
        pass

    def startElement(self, name, attrs):
        if name == 'CxXMLResults':
            self.id = attrs['DeepLink']
            self.saw_cx_xml_results = True
            self.in_cx_xml_results_node = True
        elif name == 'Query':
            self.in_query = True
            self.cwe_id = attrs['cweId']
            self.weakness_name = attrs['name']
        elif name == 'Result':
            self.in_result_node = True

            if attrs['FalsePositive'] == 'False':
                entry = {}
                entry['id'] = self.weakness_name
                entry['cwe'] = self.cwe_id
                entry['count'] = 1

                self.findings.append(entry)

    def characters(self, data):
        pass

    def endElement(self, name):
        if self.in_query_node and name == 'Query':
            self.in_query_node = False
            self.weakness_name = None
            self.cwe_id = None
        elif self.in_query_node and self.in_result_node and name == 'Result':
            self.in_result_node = False
        elif self.in_cx_xml_results_node and name == 'CxXMLResults':
            self.in_cx_xml_results_node = False
    
class CheckmarxXMLImporter(BaseXMLImporter):

    def __init__(self):
        super(CheckmarxXMLImporter, self).__init__()

    def _get_content_handler(self):
        return CheckmarxXMLContent()
