# NOTE: Before running ensure that the options are set properly in the
#       configuration file
import unittest

from tfs_response_generator import TFSResponseGenerator
from sdetools.alm_integration.tests.alm_plugin_test_base import AlmPluginTestBase
from sdetools.modules.sync_tfs.tfs_plugin import TFSConnector, TFSAPIBase

class TestTFSCase(AlmPluginTestBase, unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        alm_classes = [TFSConnector, TFSAPIBase, TFSResponseGenerator]
        super(TestTFSCase, cls).setUpClass(alm_classes=alm_classes)

    def test_parsing_alm_task(self):
        result = super(TestTFSCase, self).test_parsing_alm_task()
        test_task = result[0]
        test_task_result = result[1]

        alm_id = test_task['id'].split('T')[1]
        result_alm_id = test_task_result.get_alm_id()

        self.assertEqual(result_alm_id, alm_id, 'Expected alm_id %s, got %s' % (alm_id, result_alm_id))

    def test_api_exceptions_are_handled(self):
        pass