class ConnectorParamType(object):
    """
    The type of configuration parameter.

    STRING:         A normal text field.
    MASKED_STRING:  A masked text field (e.g. password)
    """

    STRING = 'string'
    MASKED_STRING = 'masked_string'


class CustomAttributeType(object):
    """
    The type of custom attribute.
    """

    TEXT = 'text'
    DATE = 'date'


class ConnectorParam(object):
    """
    Used by the connection plugin to describe a configuration parameter.
    """

    def __init__(self, name, label, help_text="",
                 param_type=ConnectorParamType.STRING):
        self.name = name
        self.help_text = help_text
        self.label = label
        self.param_type = param_type


class CustomAttribute(object):
    """
    Used by the connection plugin to describe a custom attribute.
    """

    def __init__(self, name, attribute_type=CustomAttributeType.TEXT):
        self.name = name
        self.attribute_type = attribute_type
