from django.shortcuts import render_to_response

from sdetools.sde_plugins.report_plugin import BaseReportPlugin


class SampleReportPlugin(BaseReportPlugin):
    """
    A sample report plugin.
    """

    title = "Sample Report"
    description = "This is a sample description"
    template = "sample_template.html"
    supported_formats = ('pdf', 'html',)
    ordinal = 1
    options = [
        {
           'name': 'foo',
           'text': 'This is a boolean option',
           'type': 'boolean',
        },
        {
            'name': 'bar',
            'text': 'This is a multi choice option',
            'type': 'enum',
            'values': [
                ('Choice A', 'value_a'),
                ('Choice B', 'value_b'),
                ('Choice C', 'value_c'),
            ]
        }
    ]

    def get_response(self, request, context):
        project = self.meta.get('project')

        tasks = project.get_tasks()

        context = {
            'title': self.title,
            'tasks': tasks
        }

        return render_to_response(self.template, context)
